Subject: Re: [2.4 PATCH] bugfix: ARP respond on all devices

From: Stephan von Krawczynski <[email-masked]>
Date: Tue, 19 Aug 2003 18:52:19 +0200

On Tue, 19 Aug 2003 08:57:17 -0700
"David S. Miller" <[email-masked]> wrote:

> On Tue, 19 Aug 2003 17:07:51 +0200
> Stephan von Krawczynski <[email-masked]> wrote:
> 
> > Hm, what rule is broken by the remote host, then?
> 
> It means that systems (like Linux) that make IP addresses owned by the
> host instead of specific interfaces cannot correctly interoperate with
> such remote systems.
> 
> It is also the case that a host cannot possibly be aware of all
> subnets present on a given LAN, therefore is should be liberal in it's
> replies to ARP requests.
> 
> Finally, it violates the most basic rule of IP networking:
> 
> "Be liberal in what you accept, and conservative in what you send"
> -Jon Postel

If I understood what Richard said in this thread Jon just shot you down. The
conservative way to _request_ arp would definitely be to request it from the
"correct" subnet, because as a sender you ought to give credit to knowing that
"bad" boxes out there won't answer if you do otherwise. There can be no doubt
what "conservative" means here.
Additionally, the remote box is not really bad behaving:

<quote RFC-985>
   A.3.  ARP datagram

      An ARP reply is discarded if the destination IP address does not
      match the local host address.  An ARP request is discarded if the
      source IP address is not in the same subnet.  It is desirable that
      this test be overridden by a configuration parameter, in order to
      support the infrequent cases where more than one subnet may
      coexist on the same cable (see RFC-925 for examples).

</quote>

This means the remote box is completely ok if not answering to a request with
source ip from another subnet.
So from what I read here requesting arp should really only happen with a source
ip from the same subnet.

Regards,
Stephan